commit:     d9f58de77b2643e2be8415c6854e36443d07c470
Author:     Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Sat Mar  1 12:56:21 2025 +0000
Commit:     Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Sat Mar  1 12:58:27 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=d9f58de7

llvm-runtimes/compiler-rt: Add 21.0.0_pre20250301 snapshot

Signed-off-by: Michał Górny <mgorny <AT> gentoo.org>

 llvm-runtimes/compiler-rt/Manifest                 |   1 +
 .../compiler-rt-21.0.0_pre20250301.ebuild          | 175 +++++++++++++++++++++
 2 files changed, 176 insertions(+)

diff --git a/llvm-runtimes/compiler-rt/Manifest 
b/llvm-runtimes/compiler-rt/Manifest
index b2d211988049..b4403db8ec73 100644
--- a/llvm-runtimes/compiler-rt/Manifest
+++ b/llvm-runtimes/compiler-rt/Manifest
@@ -15,4 +15,5 @@ DIST llvm-project-19.1.7.src.tar.xz 141249332 BLAKE2B 
1259ed7f9aca7b35e89d818bef
 DIST llvm-project-19.1.7.src.tar.xz.sig 438 BLAKE2B 
4015140f4ba77de45039bdbdfbaf6f30e75705123d067ea97175d91d7a5b6a75008df01d99ae7aa16aaa3b101f3f41e38d01f04158f95a261d617b3ede0254cd
 SHA512 
195797b06ac80a742e0ccbc03a50dc06dd2e04377d783d5474e3e72c5a75203b60292b047929312a411d22b137a239943fba414a4d136a2be14cbff978eb6bda
 DIST llvm-project-20.1.0-rc3.src.tar.xz 147194560 BLAKE2B 
888764927782b01e968c9ec326315375c6b1050d3852c7ebe7fbd06b3b4052307162f77a76f1e8976879178116ea909c581b8d1ee99dc7a4c5368b01d5597d23
 SHA512 
9de97104681de9c8039f03e94adc25fe1765280f826342fb4f616266aa0e4afe63db09a8cc3458252d8b2834e4efb2d17ed0226c62c7bb06d948ba8172ee078c
 DIST llvm-project-20.1.0-rc3.src.tar.xz.sig 566 BLAKE2B 
411ad085c3ab83c1599d110d93a9279206885a01e4748b8ac015a9a94b89fe25c35eab38b213cafb7f733be03826ffc4a01eb52788e2742d44d41a487aff2e26
 SHA512 
53c5aaa963e883ff06ac7ec9b821dcc4476b79f5be0169667843b18cd8836e8993856a045f2aab23bc77faefc2983fd822cfb1219d5644cec67132d647c877d8
+DIST llvm-project-7e8a06cfa4a2951b8ee77e19e34926e6e535b4d1.tar.gz 228792296 
BLAKE2B 
cd9357bdca9342770820f9fadfbd0b129a83324847f18e2ebac1fed8df4afb101aba2dc19d90264ae1e2d5692e34149ca24ef82a4973e7aeddb157268bb411b6
 SHA512 
9821a34a559e1db596940d76ce9388360baea43c1a9de814f567bfcf1428a0c6e3ced61b1e07537058454785d9c3aa3f443cbcf742a01fb40dd20b476a906442
 DIST llvm-project-d254fa877f419e61e54709f0a6f2e891da893a60.tar.gz 228028122 
BLAKE2B 
3321f3b205dfcd672d52122d7ba8e4e737916e01f5041a0dc140722f64359476632e036da0e0692cd366b080a073292cfdb4963e973bf800afabc20d06a2e86b
 SHA512 
135c4864973b682cf41953d43d977eaa219a4a898fceb4b4a8cacbbc6a5dd271d26010b1db6c6c90e761bf3495036f3e7528ab259d48c9c4dc4a064332c0326f

diff --git a/llvm-runtimes/compiler-rt/compiler-rt-21.0.0_pre20250301.ebuild 
b/llvm-runtimes/compiler-rt/compiler-rt-21.0.0_pre20250301.ebuild
new file mode 100644
index 000000000000..c3b2eb0428cd
--- /dev/null
+++ b/llvm-runtimes/compiler-rt/compiler-rt-21.0.0_pre20250301.ebuild
@@ -0,0 +1,175 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{10..13} )
+inherit cmake crossdev flag-o-matic llvm.org llvm-utils python-any-r1
+inherit toolchain-funcs
+
+DESCRIPTION="Compiler runtime library for clang (built-in part)"
+HOMEPAGE="https://llvm.org/";
+
+LICENSE="Apache-2.0-with-LLVM-exceptions || ( UoI-NCSA MIT )"
+SLOT="${LLVM_MAJOR}"
+IUSE="+abi_x86_32 abi_x86_64 +atomic-builtins +clang +debug test"
+REQUIRED_USE="atomic-builtins? ( clang )"
+RESTRICT="!test? ( test ) !clang? ( test )"
+
+DEPEND="
+       llvm-core/llvm:${LLVM_MAJOR}
+"
+BDEPEND="
+       clang? ( llvm-core/clang:${LLVM_MAJOR} )
+       test? (
+               $(python_gen_any_dep ">=dev-python/lit-15[\${PYTHON_USEDEP}]")
+               =llvm-core/clang-${LLVM_VERSION}*:${LLVM_MAJOR}
+       )
+       !test? (
+               ${PYTHON_DEPS}
+       )
+"
+
+LLVM_COMPONENTS=( compiler-rt cmake llvm/cmake )
+LLVM_TEST_COMPONENTS=( llvm/include/llvm/TargetParser )
+llvm.org_set_globals
+
+python_check_deps() {
+       use test || return 0
+       python_has_version ">=dev-python/lit-15[${PYTHON_USEDEP}]"
+}
+
+pkg_pretend() {
+       if ! use clang && ! tc-is-clang; then
+               ewarn "Building using a compiler other than clang may result in 
broken atomics"
+               ewarn "library. Enable USE=clang unless you have a very good 
reason not to."
+       fi
+}
+
+pkg_setup() {
+       if target_is_not_host || tc-is-cross-compiler ; then
+               # strips vars like CFLAGS="-march=x86_64-v3" for non-x86 
architectures
+               CHOST=${CTARGET} strip-unsupported-flags
+               # overrides host docs otherwise
+               DOCS=()
+       fi
+       python-any-r1_pkg_setup
+}
+
+test_compiler() {
+       target_is_not_host && return
+       $(tc-getCC) ${CFLAGS} ${LDFLAGS} "${@}" -o /dev/null -x c - \
+               <<<'int main() { return 0; }' &>/dev/null
+}
+
+src_configure() {
+       llvm_prepend_path "${LLVM_MAJOR}"
+
+       # LLVM_ENABLE_ASSERTIONS=NO does not guarantee this for us, #614844
+       use debug || local -x CPPFLAGS="${CPPFLAGS} -DNDEBUG"
+
+       # pre-set since we need to pass it to cmake
+       BUILD_DIR=${WORKDIR}/${P}_build
+
+       if use clang && ! is_crosspkg; then
+               # Only do this conditionally to allow overriding with
+               # e.g. CC=clang-13 in case of breakage
+               if ! tc-is-clang ; then
+                       local -x CC=${CHOST}-clang
+                       local -x CXX=${CHOST}-clang++
+               fi
+
+               strip-unsupported-flags
+       fi
+
+       if ! is_crosspkg && ! test_compiler ; then
+               local nolib_flags=( -nodefaultlibs -lc )
+
+               if test_compiler "${nolib_flags[@]}"; then
+                       local -x LDFLAGS="${LDFLAGS} ${nolib_flags[*]}"
+                       ewarn "${CC} seems to lack runtime, trying with 
${nolib_flags[*]}"
+               elif test_compiler "${nolib_flags[@]}" -nostartfiles; then
+                       # Avoiding -nostartfiles earlier on for bug #862540,
+                       # and set available entry symbol for bug #862798.
+                       nolib_flags+=( -nostartfiles -e main )
+
+                       local -x LDFLAGS="${LDFLAGS} ${nolib_flags[*]}"
+                       ewarn "${CC} seems to lack runtime, trying with 
${nolib_flags[*]}"
+               fi
+       fi
+
+       local mycmakeargs=(
+               
-DCOMPILER_RT_INSTALL_PATH="${EPREFIX}/usr/lib/clang/${LLVM_MAJOR}"
+
+               -DCOMPILER_RT_EXCLUDE_ATOMIC_BUILTIN=$(usex !atomic-builtins)
+               -DCOMPILER_RT_INCLUDE_TESTS=$(usex test)
+               -DCOMPILER_RT_BUILD_CTX_PROFILE=OFF
+               -DCOMPILER_RT_BUILD_LIBFUZZER=OFF
+               -DCOMPILER_RT_BUILD_MEMPROF=OFF
+               -DCOMPILER_RT_BUILD_ORC=OFF
+               -DCOMPILER_RT_BUILD_PROFILE=OFF
+               -DCOMPILER_RT_BUILD_SANITIZERS=OFF
+               -DCOMPILER_RT_BUILD_XRAY=OFF
+
+               -DPython3_EXECUTABLE="${PYTHON}"
+       )
+
+       if use amd64 && ! target_is_not_host; then
+               mycmakeargs+=(
+                       -DCAN_TARGET_i386=$(usex abi_x86_32)
+                       -DCAN_TARGET_x86_64=$(usex abi_x86_64)
+               )
+       fi
+
+       if is_crosspkg; then
+               # Needed to target built libc headers
+               export CFLAGS="${CFLAGS} -isystem /usr/${CTARGET}/usr/include"
+               mycmakeargs+=(
+                       # Without this, the compiler will compile a test program
+                       # and fail due to no builtins.
+                       -DCMAKE_C_COMPILER_WORKS=1
+                       -DCMAKE_CXX_COMPILER_WORKS=1
+
+                       # Without this, compiler-rt install location is not 
unique
+                       # to target triples, only to architecture.
+                       # Needed if you want to target multiple libcs for one 
arch.
+                       -DLLVM_ENABLE_PER_TARGET_RUNTIME_DIR=ON
+
+                       -DCMAKE_ASM_COMPILER_TARGET="${CTARGET}"
+                       -DCMAKE_C_COMPILER_TARGET="${CTARGET}"
+                       -DCOMPILER_RT_DEFAULT_TARGET_ONLY=ON
+               )
+       fi
+
+       if use prefix && [[ "${CHOST}" == *-darwin* ]] ; then
+               mycmakeargs+=(
+                       # setting -isysroot is disabled with 
compiler-rt-prefix-paths.patch
+                       # this allows adding arm64 support using SDK in EPREFIX
+                       -DDARWIN_macosx_CACHED_SYSROOT="${EPREFIX}/MacOSX.sdk"
+                       # Set version based on the SDK in EPREFIX.
+                       # This disables i386 for SDK >= 10.15
+                       -DDARWIN_macosx_OVERRIDE_SDK_VERSION="$(realpath 
${EPREFIX}/MacOSX.sdk | sed -e 's/.*MacOSX\(.*\)\.sdk/\1/')"
+                       # Use our libtool instead of looking it up with xcrun
+                       -DCMAKE_LIBTOOL="${EPREFIX}/usr/bin/${CHOST}-libtool"
+               )
+       fi
+
+       if use test; then
+               mycmakeargs+=(
+                       -DLLVM_EXTERNAL_LIT="${EPREFIX}/usr/bin/lit"
+                       -DLLVM_LIT_ARGS="$(get_lit_flags)"
+
+                       
-DCOMPILER_RT_TEST_COMPILER="${EPREFIX}/usr/lib/llvm/${LLVM_MAJOR}/bin/clang"
+                       
-DCOMPILER_RT_TEST_CXX_COMPILER="${EPREFIX}/usr/lib/llvm/${LLVM_MAJOR}/bin/clang++"
+               )
+       fi
+
+       cmake_src_configure
+}
+
+src_test() {
+       # respect TMPDIR!
+       local -x LIT_PRESERVES_TMP=1
+
+       cmake_build check-builtins
+}

Reply via email to